---
title: Markov Chain Monte Carlo for decryption
date: 2018-11-20
tags:
  - coding
  - haskell
  - markov-chain
draft: true
---

Each year I teach part of the Python programming course at the
Casimir research school, and each year I try and think of more
short projects to offer the participants during the latter half
of the course. While fishing for ideas I came across an incredibly
cool idea: using Markov chains to break classic cryptographic ciphers.

+ Found this paper
+ Idea is:
  - Analyze a reference text and obtain bigram frequencies
  - Construct a score function for a decryption key by finding
    the frequencies of bigrams in the decrypted text
  - Use this score function with the metropolis-hastings algorithm
    to walk around the key space
+ Coded up a solution in Python in a couple of hours, also wanted
  to give it a try in Haskell, to test out iHaskell and see how good
  Haskell is for "exploratory" work

+ TL;DR for exploratory work Haskell seems too restrictive. Mediocre
  library documentation and overly abstracted types make error messages
  impossible to debug

---

+ Keys are just maps between characters, we make RVars of them
+ Trying to make sense of the required pieces of RVars is intense
+ We need to run the whole markov chain before we can get the results; not cool!
  Somewhere in our monad stack we are inserting some strictness; we need to find
  out where!
